freebsd-dev/usr.sbin/bsdconfig/share/common.subr

717 lines
18 KiB
Plaintext
Raw Normal View History

if [ ! "$_COMMON_SUBR" ]; then _COMMON_SUBR=1
#
# Copyright (c) 2012 Ron McDowell
Import media selection/preparation framework (sysinstall inspired). Makes accessing files from various types of media nice and abstracted away from the wet-work involved in preparing, validating, and initializing those types of media. This will be used for the package management system module and other modules that need access to files and want to allow the user to decide where those files come from (either in a scripted fashion, prompted fashion, or any combination thereof). Heavily inspired by sysinstall and even uses the same reserved words so that scripts are portable. Coded over months, tested continuously through- out, and reviewed several times. Some notes about the changes: - Move network-setting acquisition/validation routines to media/tcpip.subr - The options screen from sysinstall has been converted to a dialog menu - The "UFS" media choice is renamed to "Directory" to reflect how sysinstall treats the choice and a new [true] "UFS" media choice has been added that acts on real UFS partitions (such as external disks with disklabels). - Many more help files have been resurrected from sysinstall (I noticed that some of the content seems a bit dated; I gave them a once-over but they could really use an update). - A total of 10 media choices are presented (via mediaGetType) including: CD/DVD, FTP, FTP Passive, HTTP Proxy, Directory, NFS, DOS, UFS, Floppy, USB - Novel struct/device management layer for managing the issue of passing more information than can comfortably fit in an argument list.
2013-02-25 19:55:32 +00:00
# Copyright (c) 2012-2013 Devin Teske
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FreeBSD$
#
############################################################ CONFIGURATION
#
# Default file descriptors to link to stdout/stderr for passthru allowing
# redirection within a sub-shell to bypass directly to the terminal.
#
: ${TERMINAL_STDOUT_PASSTHRU:=3}}
: ${TERMINAL_STDERR_PASSTHRU:=4}}
############################################################ GLOBALS
#
# Program name
#
pgm="${0##*/}"
#
# Program arguments
#
ARGC="$#"
ARGV="$@"
#
# Global exit status variables
#
SUCCESS=0
FAILURE=1
#
# Operating environment details
#
export UNAME_S="$(uname -s)" # Operating System (i.e. FreeBSD)
export UNAME_P="$(uname -p)" # Processor Architecture (i.e. i386)
export UNAME_R="$(uname -r)" # Release Level (i.e. X.Y-RELEASE)
#
# Default behavior is to call f_debug_init() automatically when loaded.
#
: ${DEBUG_SELF_INITIALIZE=1}
#
# Define standard optstring arguments that should be supported by all programs
# using this include (unless DEBUG_SELF_INITIALIZE is set to NULL to prevent
# f_debug_init() from autamatically processing "$@" for the below arguments):
#
# d Sets $debug to 1
# D: Sets $debugFile to $OPTARG
#
GETOPTS_STDARGS="dD:"
############################################################ FUNCTIONS
2013-01-03 15:48:00 +00:00
# f_dprintf $fmt [ $opts ... ]
#
# Sensible debug function. Override in ~/.bsdconfigrc if desired.
# See /usr/share/examples/bsdconfig/bsdconfigrc for example.
#
2013-01-03 15:48:00 +00:00
# If $debug is set and non-NULL, prints DEBUG info using printf(1) syntax:
# + To $debugFile, if set and non-NULL
# + To standard output if $debugFile is either NULL or unset
# + To both if $debugFile begins with a single plus-sign (`+')
#
f_dprintf()
{
[ "$debug" ] || return $SUCCESS
local fmt="$1"; shift
case "$debugFile" in ""|+*)
printf "DEBUG: $fmt${fmt:+\n}" "$@" >&${TERMINAL_STDOUT_PASSTHRU:-1}
esac
[ "${debugFile#+}" ] &&
printf "DEBUG: $fmt${fmt:+\n}" "$@" >> "${debugFile#+}"
return $SUCCESS
}
# f_debug_init
#
# Initialize debugging. Truncates $debugFile to zero bytes if set.
#
f_debug_init()
{
#
# Process stored command-line arguments
#
set -- $ARGV
local OPTIND
f_dprintf "f_debug_init: ARGV=[%s] GETOPTS_STDARGS=[%s]" \
"$ARGV" "$GETOPTS_STDARGS"
while getopts "$GETOPTS_STDARGS" flag > /dev/null; do
case "$flag" in
d) debug=1;;
D) debugFile="$OPTARG";;
\?) continue;;
esac
done
shift $(( $OPTIND - 1 ))
f_dprintf "f_debug_init: debug=[%s] debugFile=[%s]" \
"$debug" "$debugFile"
#
# Automagically enable debugging if debugFile is set (and non-NULL)
#
[ "$debugFile" ] && { [ "${debug+set}" ] || debug=1; }
#
# Make debugging persistant if set
#
[ "$debug" ] && export debug
[ "$debugFile" ] && export debugFile
#
# Truncate the debug file upon. Note that we will trim a leading plus
# (`+') from the value of debugFile to support persistant meaning that
# f_dprintf() should print both to standard output and $debugFile
# (minus the leading plus, of course).
#
local _debug_file="${debugFile#+}"
if [ "$_debug_file" ]; then
if ( umask 022 && :> "$_debug_file" ); then
f_dprintf "Successfully initialized debugFile \`%s'" \
"$_debug_file"
[ "${debug+set}" ] ||
debug=1 # turn debugging on if not set
else
unset debugFile
f_dprintf "Unable to initialize debugFile \`%s'" \
"$_debug_file"
fi
fi
}
# f_err $fmt [ $opts ... ]
#
# Print a message to stderr (fd=2).
#
f_err()
{
printf "$@" >&${TERMINAL_STDERR_PASSTHRU:-2}
}
# f_quietly $command [ $arguments ... ]
#
# Run a command quietly (quell any output to stdout or stderr)
#
f_quietly()
{
"$@" > /dev/null 2>&1
}
# f_have $anything ...
#
# A wrapper to the `type' built-in. Returns true if argument is a valid shell
# built-in, keyword, or externally-tracked binary, otherwise false.
#
f_have()
{
f_quietly type "$@"
}
# f_getvar $var_to_get [$var_to_set]
#
# Utility function designed to go along with the already-builtin setvar.
# Allows clean variable name indirection without forking or sub-shells.
#
# Returns error status if the requested variable ($var_to_get) is not set.
#
# If $var_to_set is missing or NULL, the value of $var_to_get is printed to
# standard output for capturing in a sub-shell (which is less-recommended
# because of performance degredation; for example, when called in a loop).
#
f_getvar()
{
Import media selection/preparation framework (sysinstall inspired). Makes accessing files from various types of media nice and abstracted away from the wet-work involved in preparing, validating, and initializing those types of media. This will be used for the package management system module and other modules that need access to files and want to allow the user to decide where those files come from (either in a scripted fashion, prompted fashion, or any combination thereof). Heavily inspired by sysinstall and even uses the same reserved words so that scripts are portable. Coded over months, tested continuously through- out, and reviewed several times. Some notes about the changes: - Move network-setting acquisition/validation routines to media/tcpip.subr - The options screen from sysinstall has been converted to a dialog menu - The "UFS" media choice is renamed to "Directory" to reflect how sysinstall treats the choice and a new [true] "UFS" media choice has been added that acts on real UFS partitions (such as external disks with disklabels). - Many more help files have been resurrected from sysinstall (I noticed that some of the content seems a bit dated; I gave them a once-over but they could really use an update). - A total of 10 media choices are presented (via mediaGetType) including: CD/DVD, FTP, FTP Passive, HTTP Proxy, Directory, NFS, DOS, UFS, Floppy, USB - Novel struct/device management layer for managing the issue of passing more information than can comfortably fit in an argument list.
2013-02-25 19:55:32 +00:00
local __var_to_get="$1" __var_to_set="$2"
[ "$__var_to_set" ] || local value
eval ${__var_to_set:-value}=\"\${$__var_to_get}\"
eval [ \"\${$__var_to_get+set}\" ]
local __retval=$?
eval f_dprintf '"f_getvar: var=[%s] value=[%s] r=%u"' \
Import media selection/preparation framework (sysinstall inspired). Makes accessing files from various types of media nice and abstracted away from the wet-work involved in preparing, validating, and initializing those types of media. This will be used for the package management system module and other modules that need access to files and want to allow the user to decide where those files come from (either in a scripted fashion, prompted fashion, or any combination thereof). Heavily inspired by sysinstall and even uses the same reserved words so that scripts are portable. Coded over months, tested continuously through- out, and reviewed several times. Some notes about the changes: - Move network-setting acquisition/validation routines to media/tcpip.subr - The options screen from sysinstall has been converted to a dialog menu - The "UFS" media choice is renamed to "Directory" to reflect how sysinstall treats the choice and a new [true] "UFS" media choice has been added that acts on real UFS partitions (such as external disks with disklabels). - Many more help files have been resurrected from sysinstall (I noticed that some of the content seems a bit dated; I gave them a once-over but they could really use an update). - A total of 10 media choices are presented (via mediaGetType) including: CD/DVD, FTP, FTP Passive, HTTP Proxy, Directory, NFS, DOS, UFS, Floppy, USB - Novel struct/device management layer for managing the issue of passing more information than can comfortably fit in an argument list.
2013-02-25 19:55:32 +00:00
\"\$__var_to_get\" \"\$${__var_to_set:-value}\" \$__retval
[ "$__var_to_set" ] || { [ "$value" ] && echo "$value"; }
return $__retval
}
# f_isset $var
#
# Check if variable $var is set. Returns success if variable is set, otherwise
# returns failure.
#
f_isset()
{
eval [ \"\${${1%%[$IFS]*}+set}\" ]
}
# f_die [ $status [ $fmt [ $opts ... ]]]
#
# Abruptly terminate due to an error optionally displaying a message in a
# dialog box using printf(1) syntax.
#
f_die()
{
local status=$FAILURE
# If there is at least one argument, take it as the status
if [ $# -gt 0 ]; then
status=$1
shift 1 # status
fi
# If there are still arguments left, pass them to f_show_msg
[ $# -gt 0 ] && f_show_msg "$@"
# Optionally call f_clean_up() function if it exists
f_have f_clean_up && f_clean_up
exit $status
}
# f_interrupt
#
# Interrupt handler.
#
f_interrupt()
{
exec 2>&1 # fix sh(1) bug where stderr gets lost within async-trap
f_die
}
# f_show_info $fmt [ $opts ... ]
#
# Display a message in a dialog infobox using printf(1) syntax.
#
f_show_info()
{
local msg
msg=$( printf "$@" )
#
# Use f_dialog_infobox from dialog.subr if possible, otherwise fall
# back to dialog(1) (without options, making it obvious when using
# un-aided system dialog).
#
if f_have f_dialog_info; then
f_dialog_info "$msg"
else
dialog --infobox "$msg" 0 0
fi
}
# f_show_msg $fmt [ $opts ... ]
#
# Display a message in a dialog box using printf(1) syntax.
#
f_show_msg()
{
local msg
msg=$( printf "$@" )
#
# Use f_dialog_msgbox from dialog.subr if possible, otherwise fall
# back to dialog(1) (without options, making it obvious when using
# un-aided system dialog).
#
if f_have f_dialog_msgbox; then
f_dialog_msgbox "$msg"
else
dialog --msgbox "$msg" 0 0
fi
}
# f_yesno $fmt [ $opts ... ]
#
# Display a message in a dialog yes/no box using printf(1) syntax.
#
f_yesno()
{
local msg
msg=$( printf "$@" )
#
# Use f_dialog_yesno from dialog.subr if possible, otherwise fall
# back to dialog(1) (without options, making it obvious when using
# un-aided system dialog).
#
if f_have f_dialog_yesno; then
f_dialog_yesno "$msg"
else
dialog --yesno "$msg" 0 0
fi
}
# f_noyes $fmt [ $opts ... ]
#
# Display a message in a dialog yes/no box using printf(1) syntax.
# NOTE: THis is just like the f_yesno function except "No" is default.
#
f_noyes()
{
local msg
msg=$( printf "$@" )
#
# Use f_dialog_noyes from dialog.subr if possible, otherwise fall
# back to dialog(1) (without options, making it obvious when using
# un-aided system dialog).
#
if f_have f_dialog_noyes; then
f_dialog_noyes "$msg"
else
dialog --defaultno --yesno "$msg" 0 0
fi
}
# f_show_help $file
#
# Display a language help-file. Automatically takes $LANG and $LC_ALL into
# consideration when displaying $file (suffix ".$LC_ALL" or ".$LANG" will
# automatically be added prior to loading the language help-file).
#
# If a language has been requested by setting either $LANG or $LC_ALL in the
# environment and the language-specific help-file does not exist we will fall
# back to $file without-suffix.
#
# If the language help-file does not exist, an error is displayed instead.
#
f_show_help()
{
local file="$1"
local lang="${LANG:-$LC_ALL}"
[ -f "$file.$lang" ] && file="$file.$lang"
#
# Use f_dialog_textbox from dialog.subr if possible, otherwise fall
# back to dialog(1) (without options, making it obvious when using
# un-aided system dialog).
#
if f_have f_dialog_textbox; then
f_dialog_textbox "$file"
else
dialog --msgbox "$( cat "$file" 2>&1 )" 0 0
fi
}
# f_include $file
#
# Include a shell subroutine file.
#
# If the subroutine file exists but returns error status during loading, exit
# is called and execution is prematurely terminated with the same error status.
#
f_include()
{
local file="$1"
f_dprintf "f_include: file=[%s]" "$file"
. "$file" || exit $?
}
# f_include_lang $file
#
# Include a language file. Automatically takes $LANG and $LC_ALL into
# consideration when including $file (suffix ".$LC_ALL" or ".$LANG" will
# automatically by added prior to loading the language file).
#
# No error is produced if (a) a language has been requested (by setting either
# $LANG or $LC_ALL in the environment) and (b) the language file does not
# exist -- in which case we will fall back to loading $file without-suffix.
#
# If the language file exists but returns error status during loading, exit
# is called and execution is prematurely terminated with the same error status.
#
f_include_lang()
{
local file="$1"
local lang="${LANG:-$LC_ALL}"
f_dprintf "f_include_lang: file=[%s] lang=[%s]" "$file" "$lang"
if [ -f "$file.$lang" ]; then
. "$file.$lang" || exit $?
else
. "$file" || exit $?
fi
}
# f_usage $file [ $key1 $value1 ... ]
#
# Display USAGE file with optional pre-processor macro definitions. The first
# argument is the template file containing the usage text to be displayed. If
# $LANG or $LC_ALL (in order of preference, respectively) is set, ".encoding"
# will automatically be appended as a suffix to the provided $file pathname.
#
# When processing $file, output begins at the first line containing that is
# (a) not a comment, (b) not empty, and (c) is not pure-whitespace. All lines
# appearing after this first-line are output, including (a) comments (b) empty
# lines, and (c) lines that are purely whitespace-only.
#
# If additional arguments appear after $file, substitutions are made while
# printing the contents of the USAGE file. The pre-processor macro syntax is in
# the style of autoconf(1), for example:
#
# f_usage $file "FOO" "BAR"
#
# Will cause instances of "@FOO@" appearing in $file to be replaced with the
# text "BAR" before bering printed to the screen.
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_usage_awk='
BEGIN { found = 0 }
{
if ( !found && $0 ~ /^[[:space:]]*($|#)/ ) next
found = 1
print
}
'
f_usage()
{
local file="$1"
local lang="${LANG:-$LC_ALL}"
f_dprintf "f_usage: file=[%s] lang=[%s]" "$file" "$lang"
shift 1 # file
local usage
if [ -f "$file.$lang" ]; then
usage=$( awk "$f_usage_awk" "$file.$lang" ) || exit $FAILURE
else
usage=$( awk "$f_usage_awk" "$file" ) || exit $FAILURE
fi
while [ $# -gt 0 ]; do
local key="$1"
export value="$2"
usage=$( echo "$usage" | awk \
"{ gsub(/@$key@/, ENVIRON[\"value\"]); print }" )
shift 2
done
f_err "%s\n" "$usage"
exit $FAILURE
}
# f_index_file $keyword
#
# Process all INDEX files known to bsdconfig and return the path to first file
# containing a menu_selection line with a keyword portion matching $keyword.
#
# If $LANG or $LC_ALL (in order of preference, respectively) is set,
# "INDEX.encoding" files will be searched first.
#
# If no file is found, error status is returned along with the NULL string.
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_index_file_awk='
# Variables that should be defined on the invocation line:
# -v keyword="keyword"
BEGIN { found = 0 }
( $0 ~ "^menu_selection=\"" keyword "\\|" ) {
print FILENAME
found++
exit
}
END { exit ! found }
'
f_index_file()
{
local keyword="$1"
local lang="${LANG:-$LC_ALL}"
f_dprintf "f_index_file: keyword=[%s] lang=[%s]" "$keyword" "$lang"
if [ "$lang" ]; then
awk -v keyword="$keyword" "$f_index_file_awk" \
$BSDCFG_LIBE${BSDCFG_LIBE:+/}*/INDEX.$lang &&
return
# No match, fall-thru to non-i18n sources
fi
awk -v keyword="$keyword" "$f_index_file_awk" \
$BSDCFG_LIBE${BSDCFG_LIBE:+/}*/INDEX
}
# f_index_menusel_keyword $indexfile $pgm
#
# Process $indexfile and return only the keyword portion of the menu_selection
# line with a command portion matching $pgm.
#
# This function is for internationalization (i18n) mapping of the on-disk
# scriptname ($pgm) into the localized language (given language-specific
# $indexfile). If $LANG or $LC_ALL (in orderder of preference, respectively) is
# set, ".encoding" will automatically be appended as a suffix to the provided
# $indexfile pathname.
#
# If, within $indexfile, multiple $menu_selection values map to $pgm, only the
# first one will be returned. If no mapping can be made, the NULL string is
# returned.
#
# If $indexfile does not exist, error status is returned with NULL.
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_index_menusel_keyword_awk='
# Variables that should be defined on the invocation line:
# -v pgm="program_name"
#
BEGIN {
prefix = "menu_selection=\""
plen = length(prefix)
found = 0
}
{
if (!match($0, "^" prefix ".*\\|.*\"")) next
keyword = command = substr($0, plen + 1, RLENGTH - plen - 1)
sub(/^.*\|/, "", command)
sub(/\|.*$/, "", keyword)
if ( command == pgm )
{
print keyword
found++
exit
}
}
END { exit ! found }
'
f_index_menusel_keyword()
{
local indexfile="$1" pgm="$2"
local lang="${LANG:-$LC_ALL}"
f_dprintf "f_index_menusel_keyword: index=[%s] pgm=[%s] lang=[%s]" \
"$indexfile" "$pgm" "$lang"
if [ -f "$indexfile.$lang" ]; then
awk -v pgm="$pgm" \
"$f_index_menusel_keyword_awk" \
"$indexfile.$lang"
elif [ -f "$indexfile" ]; then
awk -v pgm="$pgm" \
"$f_index_menusel_keyword_awk" \
"$indexfile"
fi
}
# f_index_menusel_command $indexfile $keyword
#
# Process $indexfile and return only the command portion of the menu_selection
# line with a keyword portion matching $keyword.
#
# This function is for mapping [possibly international] keywords into the
# command to be executed. If $LANG or $LC_ALL (order of preference) is set,
# ".encoding" will automatically be appended as a suffix to the provided
# $indexfile pathname.
#
# If, within $indexfile, multiple $menu_selection values map to $keyword, only
# the first one will be returned. If no mapping can be made, the NULL string is
# returned.
#
# If $indexfile doesn't exist, error status is returned with NULL.
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_index_menusel_command_awk='
# Variables that should be defined on the invocation line:
# -v key="keyword"
#
BEGIN {
prefix = "menu_selection=\""
plen = length(prefix)
found = 0
}
{
if (!match($0, "^" prefix ".*\\|.*\"")) next
keyword = command = substr($0, plen + 1, RLENGTH - plen - 1)
sub(/^.*\|/, "", command)
sub(/\|.*$/, "", keyword)
if ( keyword == key )
{
print command
found++
exit
}
}
END { exit ! found }
'
f_index_menusel_command()
{
local indexfile="$1" keyword="$2" command
local lang="${LANG:-$LC_ALL}"
f_dprintf "f_index_menusel_command: index=[%s] key=[%s] lang=[%s]" \
"$indexfile" "$keyword" "$lang"
if [ -f "$indexfile.$lang" ]; then
command=$( awk -v key="$keyword" \
"$f_index_menusel_command_awk" \
"$indexfile.$lang" ) || return $FAILURE
elif [ -f "$indexfile" ]; then
command=$( awk -v key="$keyword" \
"$f_index_menusel_command_awk" \
"$indexfile" ) || return $FAILURE
else
return $FAILURE
fi
#
# If the command pathname is not fully qualified fix-up/force to be
# relative to the $indexfile directory.
#
case "$command" in
/*) : already fully qualified ;;
*)
local indexdir="${indexfile%/*}"
[ "$indexdir" != "$indexfile" ] || indexdir="."
command="$indexdir/$command"
esac
echo "$command"
}
Import media selection/preparation framework (sysinstall inspired). Makes accessing files from various types of media nice and abstracted away from the wet-work involved in preparing, validating, and initializing those types of media. This will be used for the package management system module and other modules that need access to files and want to allow the user to decide where those files come from (either in a scripted fashion, prompted fashion, or any combination thereof). Heavily inspired by sysinstall and even uses the same reserved words so that scripts are portable. Coded over months, tested continuously through- out, and reviewed several times. Some notes about the changes: - Move network-setting acquisition/validation routines to media/tcpip.subr - The options screen from sysinstall has been converted to a dialog menu - The "UFS" media choice is renamed to "Directory" to reflect how sysinstall treats the choice and a new [true] "UFS" media choice has been added that acts on real UFS partitions (such as external disks with disklabels). - Many more help files have been resurrected from sysinstall (I noticed that some of the content seems a bit dated; I gave them a once-over but they could really use an update). - A total of 10 media choices are presented (via mediaGetType) including: CD/DVD, FTP, FTP Passive, HTTP Proxy, Directory, NFS, DOS, UFS, Floppy, USB - Novel struct/device management layer for managing the issue of passing more information than can comfortably fit in an argument list.
2013-02-25 19:55:32 +00:00
# f_running_as_init
#
# Returns true if running as init(1).
#
f_running_as_init()
{
#
# When a custom init(8) performs an exec(3) to invoke a shell script,
# PID 1 becomes sh(1) and $PPID is set to 1 in the executed script.
#
[ ${PPID:-0} -eq 1 ] # Return status
}
# f_mounted $local_directory
#
# Return success if a filesystem is mounted on a particular directory.
#
f_mounted()
{
local dir="$1"
[ -d "$dir" ] || return $FAILURE
mount | grep -Eq " on $dir \([^)]+\)$"
}
############################################################ MAIN
#
# Trap signals so we can recover gracefully
#
trap 'f_interrupt' SIGINT
trap 'f_die' SIGTERM SIGPIPE SIGXCPU SIGXFSZ \
SIGFPE SIGTRAP SIGABRT SIGSEGV
trap '' SIGALRM SIGPROF SIGUSR1 SIGUSR2 SIGHUP SIGVTALRM
#
# Clone terminal stdout/stderr so we can redirect to it from within sub-shells
#
eval exec $TERMINAL_STDOUT_PASSTHRU\>\&1
eval exec $TERMINAL_STDERR_PASSTHRU\>\&2
#
# Self-initialize unless requested otherwise
#
f_dprintf "%s: DEBUG_SELF_INITIALIZE=[%s]" \
dialog.subr "$DEBUG_SELF_INITIALIZE"
case "$DEBUG_SELF_INITIALIZE" in
""|0|[Nn][Oo]|[Oo][Ff][Ff]|[Ff][Aa][Ll][Ss][Ee]) : do nothing ;;
*) f_debug_init
esac
#
# Log our operating environment for debugging purposes
#
f_dprintf "UNAME_S=[%s] UNAME_P=[%s] UNAME_R=[%s]" \
"$UNAME_S" "$UNAME_P" "$UNAME_R"
f_dprintf "%s: Successfully loaded." common.subr
fi # ! $_COMMON_SUBR